#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int main()
{
    int n;
    cin >> n;
    vector< vector<int> > checkpoints(n);
    vector< vector<long double> > matrix(n);
    for (int i = 0; i < n; i++) {
        int x, y, z;
        cin >> x >> y >> z;
        checkpoints[i] = {x, y, z};
        vector<long double> m(n, -1);
        matrix[i] = m;
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) {
                continue;
            }
            long double distance = sqrt( (long double) (((checkpoints[i][0]-checkpoints[j][0])^2) + ((checkpoints[i][1]-checkpoints[j][1])^2) + ((checkpoints[i][2]-checkpoints[j][2])^2)));
            cout << i << " " << j << " " << distance << endl;
        }
    }

    return 0;
}
