#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>

using namespace std;

const int INF = 1e9;

int hex_to_dec(string s)
{
    int ans = 0;
    reverse(s.begin(), s.end());
    for (int i = 0; i < s.size(); ++i)
    {
        int curr;
        if (s[i] >= '0' && s[i] <= '9')
            curr = s[i] - '0';
        else
            curr = s[i] - 'A' + 10;
        ans += curr * pow(16, i);
    }
    reverse(s.begin(), s.end());
    return ans;
}

char digit_to_char(int d)
{
    if (d == 0)
        return '0';
    else if (d == 1)
        return '1';
    else if (d == 2)
        return '2';
    else if (d == 3)
        return '3';
    else if (d == 4)
        return '4';
    else if (d == 5)
        return '5';
    else if (d == 6)
        return '6';
    else if (d == 7)
        return '7';
    else if (d == 8)
        return '8';
    else if (d == 9)
        return '9';
    else if (d == 10)
        return 'A';
    else if (d == 11)
        return 'B';
    else if (d == 12)
        return 'C';
    else if (d == 13)
        return 'D';
    else if (d == 14)
        return 'E';
    else
        return 'F';
}

string dec_to_hex(int x)
{
    string ans;
    int n = x;
    while (n >= 16)
    {
        ans += digit_to_char(n % 16);
        n /= 16;
    }
    ans += digit_to_char(n);
    reverse(ans.begin(), ans.end());
    return ans;
}

int main()
{
    string a, b;
    cin >> a >> b;
    int c = hex_to_dec(a), d = hex_to_dec(b);
    for (int i = -16; i <= 16; ++i)
        if (c * pow(2, i) == d)
        {
            cout << i << endl;
            return 0;
        }
    cout << "NO" << endl;
    return 0;
}
