#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>

using namespace std;

int main()
{
    int n;
    cin >> n;
    vector<vector<int>> data(n, vector<int> (n));
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            cin >> data[i][j];
    vector<int> path;
    int icurr = n - 1, jcurr = 0;
    if (n % 2 == 1)
        while (!(icurr == 0 && jcurr == n - 1))
        {
            path.push_back(data[icurr][jcurr]);
            if (icurr == 0 && jcurr % 2 == 0 || icurr == n - 1 && jcurr % 2 == 1)
                jcurr++;
            else if (jcurr == 0 && icurr % 2 == 0 || jcurr == n - 1 && icurr % 2 == 1)
                icurr--;
            else if ((icurr + jcurr) % 2 == 1)
            {
                icurr++;
                jcurr++;
            }
            else
            {
                icurr--;
                jcurr--;
            }
        }
    else
        while (!(icurr == 0 && jcurr == n - 1))
        {
            path.push_back(data[icurr][jcurr]);
            if (jcurr == 0 && icurr % 2 == 1 || jcurr == n - 1 && icurr % 2 == 1)
                icurr--;
            else if (icurr == 0 && jcurr % 2 == 1 || icurr == n - 1 && jcurr % 2 == 1)
                jcurr++;
            else if ((icurr + jcurr) % 2 == 0)
            {
                icurr++;
                jcurr++;
            }
            else
            {
                icurr--;
                jcurr--;
            }
        }
    path.push_back(data[icurr][jcurr]);
    for (int i = 0; i < path.size(); ++i)
        cout << path[i] << ' ';
    cout << endl;
    return 0;
}

/*
4
7 13 14 16
6 8 12 15
2 5 9 11
1 3 4 10
*/
