#include <iostream>
#include <map>

using namespace std;

string translateto2(string t){
    map<char, string> m;
    m['0'] = "0000";
    m['1'] = "0001";
    m['2'] = "0010";
    m['3'] = "0011";
    m['4'] = "0100";
    m['5'] = "0101";
    m['6'] = "0110";
    m['7'] = "0111";
    m['8'] = "1000";
    m['9'] = "1001";
    m['A'] = "1010";
    m['B'] = "1011";
    m['C'] = "1100";
    m['D'] = "1101";
    m['E'] = "1110";
    m['F'] = "1111";
    return m[t[0]] + m[t[1]] + m[t[2]] + m[t[3]];
}

string moveleft(string s, int x){
    for (int i = 0; i < x; ++i){
        string temp = "";
        char first = s[0];
        for (int d = 1; d < s.size(); ++d) temp = temp + s[d];
        temp = temp + first;
        s = temp;
    }
    return s;
}

string getans(string a, string s){
    string ans = "";
    for (int i = 0; i < 16; ++i){
        if (a[i] == '0' && s[i] == '0') ans = ans + "0";
        if (a[i] == '0' && s[i] == '1') ans = ans + "1";
        if (a[i] == '1' && s[i] == '0') ans = ans + "1";
        if (a[i] == '1' && s[i] == '1') ans = ans + "0";
    }
    return ans;
}

string translateto16(string s){
    map<string, char> m;
    m["0000"] = '0';
    m["0001"] = '1';
    m["0010"] = '2';
    m["0011"] = '3';
    m["0100"] = '4';
    m["0101"] = '5';
    m["0110"] = '6';
    m["0111"] = '7';
    m["1000"] = '8';
    m["1001"] = '9';
    m["1010"] = 'A';
    m["1011"] = 'B';
    m["1100"] = 'C';
    m["1101"] = 'D';
    m["1110"] = 'E';
    m["1111"] = 'F';
    string t1 = "", t2 = "", t3 = "", t4 = "";
    t1 = t1 + s[0] + s[1] + s[2] + s[3];
    t2 = t2 + s[4] + s[5] + s[6] + s[7];
    t3 = t3 + s[8] + s[9] + s[10] + s[11];
    t4 = t4 + s[12] + s[13] + s[14] + s[15];
    string ans = "";
    ans = ans + m[t1] + m[t2] + m[t3] + m[t4];
    return ans;
}

int main(){
    string a, ans;
    int k;
    cin >> a >> k >> ans;
    //cout << translateto2(a) << " " << translateto2(ans) << endl;
    //cout << moveleft(ans, k) << endl;
    //cout << getans()
    cout << translateto16(getans(translateto2(a), moveleft(translateto2(ans), k)));
}
