#include <iostream>
#include <map>
#include <vector>
#include <algorithm>

using namespace std;

struct Bunch{
    string name;
    int c, k;
};

int tr(string s){
    int ans = 0;
    for (int i = 0; i < s.size(); ++i){
        ans = ans * 10 + (s[i] - '0');
    }
    return ans;
}

bool cmp(Bunch a, Bunch b){
    //cout << 1.0 * a.c / a.k << " " << 1.0 * b.c / b.k << endl;
    if (1.0 * a.c / a.k == 1.0 * b.c / b.k) return a.k > b.k;
    return 1.0 * a.c / a.k < 1.0 * b.c / b.k;
}

int main(){
    vector<Bunch> a;
    vector<pair<string, bool> > order;
    int n, m, x;
    cin >> n >> m >> x;
    map<string, int> cost, kolvo;
    for (int i = 0; i < n; ++i){
        string ts;
        int tn;
        cin >> ts >> tn;
        cost[ts] = tn;
        order.push_back(make_pair(ts, false));
    }
    string temp; getline(cin, temp);
    for (int i = 0; i < m; ++i){
        string temp;
        getline(cin, temp); //cout << temp << endl;
        vector<string> add;
        while (temp.find(' ') >= 0 && temp.find(' ') < temp.size()){
            string s = temp.substr(0, temp.find(' '));
            temp.erase(0, temp.find(' ') + 1);
            add.push_back(s);
        }
        int curadd = tr(temp);
        for (int i = 0; i < add.size(); ++i){
            kolvo[add[i]] += curadd;
        }
        //for (int i = 0; i < add.size(); ++i) cout << add[i] << " "; cout << endl;
    }
    /*for (map<string, int>::iterator now = cost.begin(); now != cost.end(); ++now){
        cout << now->first << " " << now->second << endl;
    }
    for (map<string, int>::iterator now = kolvo.begin(); now != kolvo.end(); ++now){
        cout << now->first << " " << now->second << endl;
    }*/
    for (map<string, int>::iterator now = cost.begin(); now != cost.end(); ++now){
        Bunch t;
        t.name = now->first;
        t.c = now->second;
        t.k = kolvo[now->first];
        a.push_back(t);
    }
    sort(a.begin(), a.end(), cmp);
    //for (int i = 0; i < a.size(); ++i) cout << a[i].name << " " << a[i].c << " " << a[i].k << endl;
    int cursum = 0, ans = 0;
    for (int i = 0; i < a.size(); ++i){
        if (cursum + a[i].c <= x){
            cursum += a[i].c;
            ans++;
            for (int j = 0; j < order.size(); ++j){
                if (order[j].first == a[i].name){
                    order[j].second = true;
                }
            }
        }
    }
    cout << ans << endl;
    for (int i = 0; i < order.size(); ++i){
        if (order[i].second) cout << order[i].first << endl;
    }
}
