#include <bits/stdc++.h>

using namespace std;

#define deb(a) cerr << #a << " = " << a << '\n'
#define debo(a) cout << #a << " = " << a << '\n'
typedef long long ll;
typedef long double ld;

const int INF = 2e9;
const int MXN = 1e5 + 5;

struct T {
    string name;
    ll sz = 0, cnt = 0;
};

ll n, m, x;
vector<T> g;
map<string, T> mp;

bool comp(T a, T b) {
    return a.cnt > b.cnt;
}

bool comp2(T a, T b) {
    return a.cnt < b.cnt;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(10);

    cin >> n >> m >> x;

    for (int i = 0; i < n; i++) {
        string s;
        ll sz;
        cin >> s >> sz;
        mp[s].sz = sz;
    }

    for (int i = 0; i < m; i++) {
        string s;
        vector<string> te;
        ll cnt;
        while (true) {
            cin >> s;
            if (isdigit(s[0])) {
                cnt = stoi(s);
                break;
            } else {
                te.push_back(s);
            }
        }
        for (auto i : te) {
            mp[i].cnt += cnt;
        }
    }

    g.resize(mp.size());
    ll c = 0;
    for (auto i : mp) {
        g[c].name = i.first;
        g[c].sz = i.second.sz;
        g[c].cnt = i.second.cnt;
        c++;
    }

    vector<string> ans;

    sort(g.begin(), g.end(), comp);

    ll tempx = x, cnt1 = 0, cnt2 = 0;

    for (auto i : g) {
        if (x - i.sz >= 0) {
            x -= i.sz;
            cnt1 += i.cnt;
            ans.push_back(i.name);
        }
    }
    vector<string> ans2;
    sort(g.begin(), g.end(), comp2);

    for (auto i : g) {
        if (tempx - i.sz >= 0) {
            tempx -= i.sz;
            cnt2 += i.cnt;
            ans2.push_back(i.name);
        }
    }

    if (cnt1 > cnt2) {

        cout << ans.size() << '\n';

        for (auto i : ans) {
            cout << i << '\n';
        }
    } else {
        cout << ans2.size() << '\n';

        for (auto i : ans2) {
            cout << i << '\n';
        }
    }
    return 0;
}
