#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

int main()
{

    int n;
    cin >> n;
    vector<vector<int> > vec(n, vector<int>(3));

    vector<bool> was(n);

    for(int i = 0; i<n; i++){
        cin >> vec[i][0] >> vec[i][1] >> vec[i][2];
    }

    vector<int> ans;
    double fullway = 0;

    int xlast = 0, ylast = 0, zlast = 0;

    while(!was[0] || !was[1] || !was[2]){
        int pos = -1;
        double len = 1e9;
        for(int i = 0; i<n; i++){
            int delx = abs(vec[i][0]-xlast);

            int dely = abs(vec[i][1]-ylast);
            int delz = abs(vec[i][2]-zlast);
            double now = sqrt(delx*delx+dely*dely+delz*delz);

            if(pos<=2 && i<=2 && now<len && !was[i] && now<20){
                len = now;
                pos = i;
            }

            if(!was[i] && now<len && now<20){
                len = now;
                pos = i;
            }

        }

        was[pos] = true;
        ans.push_back(pos);
        fullway+=len;
        xlast = vec[pos][0];
        ylast = vec[pos][1];
        zlast = vec[pos][2];

    }
    fullway+=0.00049999999;
    cout << fixed;
    cout.precision(3);

    cout << ans.size() << ' ' << fullway << endl;
    for(int i = 0; i<ans.size(); i++){
        cout << ans[i]+1 << ' ';
    }
    cout << endl;

    return 0;
}
