#include <iostream>
#include <vector>
#include <map>

using namespace std;

int n, m, x;
map<string, int> cost;
map<string, int> calls;
vector<string> st;

int ans = 0;
string saved = "";

int from_str_to_int(string s) {
    int res = 0;
    for (int i = 0; i < s.size(); ++i) {
        res *= 10;
        res += (s[i] - '0');
    }
    return res;
}

void f(string curr) {
    if (curr.size() == n) {
        int num_call = 0;
        int num_cost = 0;
        for (int i = 0; i < n; ++i) {
            if (curr[i] == '1') {
                num_call += calls[st[i]];
                num_cost += cost[st[i]];
            }
        }
        if (num_cost <= x && num_call > ans) {
            ans = num_call;
            saved = curr;
        }
        return;
    }
    f(curr + "0");
    f(curr + "1");
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin >> n >> m >> x;
    if (n >= 25) {
        cout << 0;
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        string s; cin >> s;
        st.push_back(s);
        int x; cin >> x;
        cost[s] = x;
    }
    for (int i = 0; i < m; ++i) {
        vector<string> add;
        int x = 0;
        while (true) {
            string s; cin >> s;
            if (cost.find(s) != cost.end()) {
                add.push_back(s);
            } else {
                x = from_str_to_int(s);
                break;
            }
        }
        for (auto u: add) {
            calls[u] += x;
        }
    }
    f("");
    vector<string> ans;
    for (int i = 0; i < n; ++i) {
        if (saved[i] == '1') {
            ans.push_back(st[i]);
        }
    }
    cout << ans.size() << endl;
    for (auto x: ans) {
        cout << x << endl;
    }
}


