#include<iostream>
#include<map>
#include<vector>
#include<string>
#include<algorithm>

using namespace std;
int call(string name, map<string, vector<string>>& proc, map<string, int>& memmap, int depth, int maxdepth) {
	int col = 1;
	if (depth != maxdepth) {
		for (int i = 0; i < proc[name].size(); i++) {
			col += call(proc[name][i], proc, memmap,  depth + 1, maxdepth);
		}
	}
	return col;
}

void trace(string name, map<string, vector<string>>& proc, map<string, int>& memmap, int depth, int maxdepth, int mem, int maxmem, vector<string> stack) {
	for (int i = 0; i < stack.size(); i++) {
		cout << stack[i] << ' ';
	}
	cout << name << ' ';
	stack.push_back(name);
	int curr = mem + memmap[name];
	if (curr > maxmem) {
		cout << "OVERFLOW" << endl;
	}
	else cout << curr << endl;

	if (depth != maxdepth) {
		for (int i = 0; i < proc[name].size(); i++) {
			trace(proc[name][i], proc, memmap, depth + 1, maxdepth, curr, maxmem, stack);
		}
	}
}

int main() {
	int callcol, stack, n;
	char c;
	n = 0;
	cin >> callcol >> stack;
	bool mainproc;
	mainproc = 0;
	map<string, vector<string>> proc;
	map<string, int> memmap;
	vector<string> calls;

	string inp;
	while (!mainproc) {
		cin >> inp;
		if (inp == "PROC") {
			string name,called;
			cin >> name;
			if (name != "MAIN") {
				int K;
				cin >> K;

				vector<string> clean(0);
				proc[name] = clean;
				memmap[name] = K;
				string comm;
				cin >> comm;
				while (comm == "CALL") {
					cin >> called;
					proc[name].push_back(called);
					cin >> comm;
				}
			}
			else {
				mainproc = 1;
				string comm;
				cin >> comm;
				while (comm == "CALL") {
					cin >> called;
					calls.push_back(called);
					n += call(called, proc, memmap, 1, callcol);
					cin >> comm;
				}
			}
		}
	}
	cin >> c;
	cout << n << endl;
	for (int i = 0; i < calls.size();i++) {
		trace(calls[i], proc, memmap, 1, callcol, 0, stack, vector<string>());
	}
}
