#include <bits/stdc++.h>

using namespace std;

double dst(vector<int> &v1, vector<int> v2) {
    return sqrt((v1[0] - v2[0]) * (v1[0] - v2[0]) + (v1[1] - v2[1]) * (v1[1] - v2[1]) + (v1[2] - v2[2]) * (v1[2] - v2[2]));
}

double dks(vector<vector<int> > &graph, vector<vector<int> > &vect, int st, int fin, int n) {
    priority_queue<pair<int, int> > q;
    q.push({0, st});
    vector<bool> visited(n + 1);
    vector<pair<int, double> > dist(n + 1, {1e9, 1e9});
    vector<int> prev(n + 1, -1);
    dist[st] = {0, 0.};
    vector<int> story;
    while (!q.empty()) {
        int v = q.top().second;
        q.pop();
        visited[v] = true;
        for (auto x : graph[v]) {
            if (visited[x])
                continue;
            if (dist[x].first > 1 + dist[v].first || dist[x].first == 1 + dist[v].first && dist[x].second > dst(vect[x], vect[v]) + dist[v].second) {
                dist[x] = {1 + dist[v].first, dst(vect[x], vect[v]) + dist[v].second};
                q.push({-dist[x].first, x});
                prev[x] = v;
            }
        }
    }
    return dist[fin].second;
}

int main() {
    int n;
    cin >> n;
    vector<vector<int> > vect(n, vector<int> (3));
    for (int i = 0; i < n; ++i) {
        cin >> vect[i][0] >> vect[i][1] >> vect[i][2];
    }
    vect.push_back({0, 0, 0});
    vector<vector<int> > graph(n + 1);
    for (int i = 0; i < n + 1; ++i) {
        for (int j = i + 1; j < n + 1; ++j) {
            if (dst(vect[i], vect[j]) <= 20.) {
                graph[i].push_back(j);
                graph[j].push_back(i);
            }
        }
    }

    double ans = 0.;
    ans = dst(vect[0], {0, 0, 0}) + dst(vect[1], vect[0]) + dst(vect[2], vect[1]);
    ans = min(ans, dst(vect[1], {0, 0, 0}) + dst(vect[1], vect[0]) + dst(vect[2], vect[0]));
    ans = min(ans, dst(vect[2], {0, 0, 0}) + dst(vect[1], vect[2]) + dst(vect[1], vect[0]));
    ans = min(ans, dst(vect[1], {0, 0, 0}) + dst(vect[1], vect[2]) + dst(vect[2], vect[0]));
    ans = min(ans, dst(vect[2], {0, 0, 0}) + dst(vect[2], vect[0]) + dst(vect[1], vect[0]));
    ans = min(ans, dst(vect[1], {0, 0, 0}) + dst(vect[1], vect[0]) + dst(vect[2], vect[0]));
    cout << "3 " << ans << '\n';
    cout << "1 2 3";
    return 0;
}
