#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    int n, k;
    cin >> n >> k;
    vector<int> seats(k);
    for (int i = 0; i < k; i++) {
        cin >> seats[i];
    }

    vector< vector<int> > vars;
    vector<int> v0(k+2, 0);
    vars.push_back(v0);

    for (int i = 0; i < k; i++) {
        vector< vector<int> > internal = vars;
        for (vector<int> v : vars) {
            int sum = v[0], c = 0;
            for (; sum < n; sum += seats[i]) {
                vector<int> vn = v;
                vn[0] = sum;
                vn[1] += c;
                vn[i+2] = c;
                internal.push_back(vn);
                c++;
            }
            vector<int> vn = v;
            vn[0] = sum;
            vn[1] += c;
            vn[i+2] = c;
            internal.push_back(vn);
        }
        vars = internal;
    }

    sort(vars.begin(), vars.end(), [](vector<int> a, vector<int> b) {
         if (a[0] == b[0]) {
            return a[1] < b[1];
         }
         return a[0] < b[0];
         });

    for (vector<int> v : vars) {
        if (v[0] >= n) {
            cout << v[0]-n << endl;
            cout << v[2];
            for (int i = 1; i < k; i++) {
                cout << " " << v[i+2];
            }
            cout << endl;
            return 0;
        }
    }

    return 0;
}
