#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int INF = 1e9;

vector<int> f(int x)
{
    int n = x;
    vector<int> ans;
    while (n >= 10)
    {
        ans.push_back(n % 10);
        n /= 10;
    }
    ans.push_back(n);
    reverse(ans.begin(), ans.end());
    return ans;
}

int check(vector<int> d)
{
    vector<int> vec;
    for (int i = 1; i < d.size(); ++i)
        vec.push_back(d[i] - d[i - 1]);
    int bad = 0;
    for (int i = 1; i < vec.size(); ++i)
        if (vec[i] != vec[0])
            bad++;
    if (bad > 0)
        return INF;
    else
        return d[1] - d[0];
}

int main()
{
    int n;
    cin >> n;
    if (n < 10)
    {
        cout << 0 << endl;
        return 0;
    }
    if (n < 100)
    {
        cout << n % 10 - int((n - n % 10) / 10) << endl;
        return 0;
    }
    int delta = check(f(n));
    if (delta == INF || delta == 0)
        cout << 0 << endl;
    else
        cout << delta << endl;
    return 0;
}
