#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>

using namespace std;

vector<string> ans;

int str_to_int(string& s, int left, int right)
{
    int ans = s[left] - '0';
    for (int i = left + 1; i <= right; ++i)
    {
        ans *= 10;
        ans += (s[i] - '0');
    }
    return ans;
}

string get(string& s, int left, int right)
{
    string ans;
    for (int i = left; i <= right; ++i)
        ans += s[i];
    return ans;
}

void solve(string& s, int curr, int result, string eq, int k)
{
    if (ans.size() > 0)
        return;
    if (curr == s.size())
    {
        if (result == 0)
            ans.push_back(eq);
        return;
    }
    solve(s, curr + k, result + str_to_int(s, curr, curr + k - 1), eq + '+' + get(s, curr, curr + k - 1), k);
    solve(s, curr + k, result - str_to_int(s, curr, curr + k - 1), eq + '-' + get(s, curr, curr + k - 1), k);
}

int main()
{
    string s;
    cin >> s;
    for (int k = s.size(); k >= 1; --k)
        if (s.size() % k == 0)
            solve(s, k, str_to_int(s, 0, k - 1), get(s, 0, k - 1), k);
    if (ans.size() > 0)
        cout << ans[0] << endl;
    else
        cout << "NO" << endl;
    //for (int i = 0; i < ans.size(); ++i)
        //cout << ans[i] << endl;
    return 0;
}
