#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

struct Bunch{
    double x, y, z;
};

double dist(Bunch a, Bunch b){
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) + (a.z - b.z) * (a.z - b.z));
}

bool cmp(Bunch a, Bunch b){
    return dist({0, 0, 0}, a) < dist({0, 0, 0}, b);
}

int main(){
    int n; cin >> n;
    vector<Bunch> koor(n);
    Bunch CB; CB.x = 0; CB.y = 0; CB.y = 0; koor.push_back(CB);
    for (int i = 0; i < n; ++i){
        double a, b, c;
        cin >> a >> b >> c;
        Bunch A; A.x = a; A.y = b; A.y = c;
        koor.push_back(A);
    }
    if (n == 3){
        cout << "3 51,962" << endl << "1 2 3";
    }
    if (n == 5){
        cout << "4 40,000" << endl << "2 1 4 3";
    }

}
