#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) cin >> a[i][j];
    }

    vector<int> ans;
    int i = 0, j = n - 1;
    bool odd = false;
    while (i != n - 1 || j != 0)
    {
        int new_i = i, new_j = j;
        vector<int> sub;
        while (new_i < n && new_j < n)
        {
            sub.push_back(a[new_i][new_j]);
            //cout << "{ " << new_i << " " << new_j << "} ";
            new_i++; new_j++;
        }
        if (odd) {
            for (int p = sub.size() - 1; p >= 0; p--) ans.push_back(sub[p]);
        }
        else {
            for (int x : sub) ans.push_back(x);
        }
        //cout << "\n";
        if (j == 0) i++;
        else j--;
        odd = !odd;
    }   
    ans.push_back(a[i][j]);
    int sz = ans.size();
    for (int i = 0; i < sz; i++) {
        if (i == sz - 1) cout << ans[i];
        else cout << ans[i] << " ";
    }
}

/*
5
11 10 4 3 1
19 12 9 5 2
20 18 13 8 6
24 21 17 14 7
25 23 21 16 15
*/