from math import sqrt

def calc_dist(p1, p2):
    return sqrt(abs(p1[0] - p2[0]) + abs(p1[1] - p2[1]) + abs(p1[2] - p2[2]))

def bfs(i, cur_dist, visited, put):
    global p, g, dst
    visited[i] = 1
    put.append(i)
    if cur_dist < dst[i][0]:
        dst[i][0] = cur_dist
        dst[i][1] = put
        for j in range(len(g)):
            if j != i and visited[j] != 1 and calc_dist(p[i], p[j]) <= 20:
                bfs(j, cur_dist + 1, visited.copy(), put.copy())
    
    
    

n = int(input())

p = [[0, 0, 0]]

for _ in range(n):
    p.append(list(map(int, input().split())))

g = [[10 ** 9] * (n + 1) for _ in range(n + 1)]

for i, p1 in enumerate(p):
    for j, p2 in enumerate(p):
        if i != j:
            dist = calc_dist(p1, p2)
            g[i][j] = dist
            g[j][i] = dist

to_visit = []
for i in range(1, 4):
    to_visit.append([i, calc_dist(p[0], p[i])])

to_visit.sort(key=lambda x: x[1])
last_visited = 0
global_put = [0]
for i in range(3):
    dst = [[10 ** 9, []] for _ in range(n + 1)]
    visited = [0] * (n + 1)
    bfs(last_visited, 0, visited, [])
    last_visited = to_visit[i][0]
    global_put += dst[to_visit[i][0]][1][1:]

print(len(global_put) - 1, end=" ")
sum_dist = 0
for i in range(len(global_put) - 1):
    sum_dist += calc_dist(p[global_put[i]], p[global_put[i + 1]])
print(sum_dist)

for p in global_put:
    if p != 0:
        print(p, end=" ")





    

