#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct ret {
	int height;
	bool isBalance;
};

ret rec(vector <int> input) {
	if (input.size() < 2)
		return { (int)input.size(), true };
	
	vector <int> left, right;
	int i = 1;

	while (i < input.size() && input[i] < input[0])
		left.push_back(input[i++]);
	while (i < input.size())
		right.push_back(input[i++]);

	ret leftRet = rec(left);
	ret rightRet = rec(right);

	return { max(leftRet.height, rightRet.height) + 1, (leftRet.isBalance & rightRet.isBalance) && abs(leftRet.height - rightRet.height) <= 1};
}

int main() {
	vector <int> input;
	int i;

	while (cin >> i) {
		input.push_back(i);
	}
	ret ans = rec(input);

	cout << (ans.isBalance ? "YES" : "NO") << "\n" << ans.height;
	return 0;
}