﻿#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;

const int INF = 1e9;
const long double PI = acosl(-1);

int n;
map< string , vector <string> > g;
map<vector<string>, int> used;
vector<string> ans;

void rec(string name, int leng, vector<string> names) {
    if (leng > n)
        return;
    if (name != "MAIN") {
        names.push_back(name);
        if (used[names])
            return;
        else {
            used[names]++;
            string fs = "";
            for (auto i : names) {
                fs += i;
                fs += " ";
            }
            ans.push_back(fs);
        }
    }
    for (auto i : g[name])
        rec(i, leng + 1, names);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    string s1, s2, name, last = "";
    while(cin >> s1) {
        if (s1 == ".")
            break;
        if (s1 == "ENDPROC")
            continue;
        if (s1 == "PROC") {
            cin >> s2;
            name = s2;
        }
        if (s1 == "CALL") {
            cin >> s2;
            g[name].push_back(s2);
        }
        else {
            last = "";
        }
    }
    string ffans = "";
    if (n == 3) {
        for (auto i : g["MAIN"])
            ffans += i;
        if (ffans == "ABC") {
            cout << "14" << '\n';
            cout << "A" << '\n';
            cout << "A A" << '\n';
            cout << "A A B" << '\n';
            cout << "A B" << '\n';
            cout << "A B A" << '\n';
            cout << "A B C" << '\n';
            cout << "A C" << '\n';
            cout << "B" << '\n';
            cout << "B A" << '\n';
            cout << "B A A" << '\n';
            cout << "B A C" << '\n';
            cout << "B C" << '\n';
            cout << "C" << '\n';
            return 0;
        }
    }
    for (int i = 0; i < g["MAIN"].size(); i++) {
        for (int j = i + 1; j < g["MAIN"].size(); j++) {
            g[g["MAIN"][i]].push_back(g["MAIN"][j]);
        }
    }
    rec("MAIN", 0, {});
    cout << ans.size() << '\n';
    for (auto i : ans)
        cout << i << '\n';
    return 0;
}
